Index: /trunk/src/org/expeditee/reflection/PackageLoader.java
===================================================================
--- /trunk/src/org/expeditee/reflection/PackageLoader.java	(revision 1101)
+++ /trunk/src/org/expeditee/reflection/PackageLoader.java	(revision 1102)
@@ -36,271 +36,269 @@
 public class PackageLoader {
 
-    // The following is adapted from:
-    // http://stackoverflow.com/questions/1456930/how-do-i-read-all-classes-from-a-java-package-in-the-classpath
-
-    public static List<Class<?>> getClassesNew(String packageName)
-	    throws ClassNotFoundException {
-
-	ClassLoader classLoader = Thread.currentThread()
-		.getContextClassLoader();
-
-	ArrayList<String> names = new ArrayList<String>();
-	;
-	final ArrayList<Class<?>> classes = new ArrayList<Class<?>>();
-
-	String realPackageName = packageName;
-	packageName = packageName.replace(".", "/");
-	URL packageURL = classLoader.getResource(packageName);
-
-	if (packageURL.getProtocol().equals("jar")) {
-
-	    // build jar file name, then loop through zipped entries
-
-	    String jarFileNameUndecoded = packageURL.getFile();
-
-	    try {
-		JarURLConnection ju_connection = (JarURLConnection) packageURL
-			.openConnection();
-		JarFile jf = ju_connection.getJarFile();
-
-		Enumeration<JarEntry> jarEntries = jf.entries();
-		while (jarEntries.hasMoreElements()) {
-		    String entryName = jarEntries.nextElement().getName();
-
-		    if (entryName.startsWith(packageName)) {
-
-			if (entryName.endsWith(".class")
-				&& !entryName.contains("$")) {
-
-			    // Deal with situation where the class found might
-			    // be a further sub-package
-			    // e.g. for "org.expeditee.action"
-			    // there is:
-			    // org/expeditee/action/widgets/Chart.class
-			    // which would produce a value of 'entryName' as
-			    // widgets/Chart.class
-
-			    entryName = entryName.substring(0,
-				    entryName.length() - 6); // 6 = '.class'
-			    entryName = entryName.replace('/', '.');
-
-			    names.add(entryName);
-			    classes.add(Class.forName(entryName));
-			}
-		    }
+	// The following is adapted from:
+	// http://stackoverflow.com/questions/1456930/how-do-i-read-all-classes-from-a-java-package-in-the-classpath
+
+	public static List<Class<?>> getClassesNew(String packageName) throws ClassNotFoundException
+	{
+		ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
+
+		ArrayList<String> names = new ArrayList<String>();
+
+		final ArrayList<Class<?>> classes = new ArrayList<Class<?>>();
+
+		String realPackageName = packageName;
+		packageName = packageName.replace(".", "/");
+		URL packageURL = classLoader.getResource(packageName);
+
+		if (packageURL.getProtocol().equals("jar")) {
+
+			// build jar file name, then loop through zipped entries
+
+			String jarFileNameUndecoded = packageURL.getFile();
+
+			try {
+				JarURLConnection ju_connection = (JarURLConnection) packageURL
+						.openConnection();
+				JarFile jf = ju_connection.getJarFile();
+
+				Enumeration<JarEntry> jarEntries = jf.entries();
+				while (jarEntries.hasMoreElements()) {
+					String entryName = jarEntries.nextElement().getName();
+
+					if (entryName.startsWith(packageName)) {
+
+						if (entryName.endsWith(".class")
+								&& !entryName.contains("$")) {
+
+							// Deal with situation where the class found might
+							// be a further sub-package
+							// e.g. for "org.expeditee.action"
+							// there is:
+							// org/expeditee/action/widgets/Chart.class
+							// which would produce a value of 'entryName' as
+							// widgets/Chart.class
+
+							entryName = entryName.substring(0,
+									entryName.length() - 6); // 6 = '.class'
+							entryName = entryName.replace('/', '.');
+
+							names.add(entryName);
+							classes.add(Class.forName(entryName));
+						}
+					}
+				}
+			} catch (Exception e) {
+				System.err.println("Failed to decode jar file: "
+						+ jarFileNameUndecoded);
+				e.printStackTrace();
+			}
+		} else if (packageURL.getProtocol().equals("bundleresource")) {
+			try {
+				final URLConnection urlConnection = packageURL.openConnection();
+				final Class<?> c = urlConnection.getClass();
+				final java.lang.reflect.Method toInvoke = c.getMethod("getFileURL");
+				final URL fileURL = (URL)toInvoke.invoke(urlConnection);
+				final File folder = new File(fileURL.getFile());
+				final List<String> files = findFiles(folder);
+				for (final String s : files) {
+					String entryName = realPackageName + s;
+					if (entryName.endsWith(".class") && !entryName.contains("$")) {
+						entryName = entryName.substring(0, entryName.lastIndexOf('.'));
+						entryName = entryName.replace('/', '.');
+						names.add(entryName);
+						try {
+							final Class<?> tmpc = Class.forName(entryName);
+							classes.add(tmpc);
+						} catch (NoClassDefFoundError e) {
+							System.err.println("Unable to instantiate class " + entryName);
+							System.err.println(e.getMessage());
+						}
+					}
+				}
+			} catch (final Exception e) {
+				System.err.println("Failed to process file: " + packageName);
+				e.printStackTrace();
+			}
+		} else {
+			// loop through files in classpath
+
+			String packageURLString = packageURL.toString();
+			try {
+				URI uri = new URI(packageURLString);
+				File folder = new File(uri.getPath());
+
+				List<String> files = findFiles(folder);
+				for (String s : files) {
+					String entryName = realPackageName + s;
+
+					if (entryName.endsWith(".class")
+							&& !entryName.contains("$")) {
+						entryName = entryName.substring(0,
+								entryName.lastIndexOf('.'));
+						entryName = entryName.replace('/', '.');
+
+						names.add(entryName);
+						classes.add(Class.forName(entryName));
+					}
+				}
+			} catch (Exception e) {
+				System.err.println("Failed to process file: "
+						+ packageURLString);
+				e.printStackTrace();
+			}
 		}
-	    } catch (Exception e) {
-		System.err.println("Failed to decode jar file: "
-			+ jarFileNameUndecoded);
-		e.printStackTrace();
-	    }
-	} else if (packageURL.getProtocol().equals("bundleresource")) {
-	    try {
-		final URLConnection urlConnection = packageURL.openConnection();
-		final Class<?> c = urlConnection.getClass();
-		final java.lang.reflect.Method toInvoke = c.getMethod("getFileURL");
-		final URL fileURL = (URL)toInvoke.invoke(urlConnection);
-		final File folder = new File(fileURL.getFile());
-		final List<String> files = findFiles(folder);
-		for (final String s : files) {
-		    String entryName = realPackageName + s;
-		    if (entryName.endsWith(".class") && !entryName.contains("$")) {
-			entryName = entryName.substring(0, entryName.lastIndexOf('.'));
-			entryName = entryName.replace('/', '.');
-			names.add(entryName);
+
+		return classes;
+	}
+
+	/**
+	 * Finds all files in a directory and it's subdirectories
+	 * 
+	 * @param directory
+	 *            The folder to start in
+	 * 
+	 * @return A list of Strings containing file paths relative to the starting
+	 *         directory
+	 */
+	private static List<String> findFiles(File directory) {
+		List<String> files = new LinkedList<String>();
+		for (File f : directory.listFiles()) {
+			if (f.isDirectory()) {
+				for (String s : findFiles(f)) {
+					files.add(f.getName() + "/" + s);
+				}
+			} else {
+				files.add(f.getName());
+			}
+		}
+		return files;
+	}
+
+	public static List<Class<?>> getClasses(final String pckgname)
+			throws ClassNotFoundException {
+
+		final ArrayList<Class<?>> classes = new ArrayList<Class<?>>();
+
+		// Must be a forward slash for loading resources
+		final String packagePath = pckgname.replace('.', '/');
+
+		if (System.getProperty("eclipse.expeditee.home") == null) {
+			final ClassLoader cld = Thread.currentThread()
+					.getContextClassLoader();
+			if (cld == null) {
+				throw new ClassNotFoundException("Can't get class loader.");
+			}
+			URL resource = null;
 			try {
-			    final Class<?> tmpc = Class.forName(entryName);
-			    classes.add(tmpc);
-			} catch (NoClassDefFoundError e) {
-			    System.err.println("Unable to instantiate class " + entryName);
-			    System.err.println(e.getMessage());
-			}
-		    }
+				final Enumeration<URL> resources = cld
+						.getResources(packagePath);
+				while (resources.hasMoreElements()) {
+					URL url = resources.nextElement();
+					resource = url;
+				}
+			} catch (IOException e) {
+				System.err
+				.println("A IO Error has occured when trying to use the ContextClassLoader"
+						+ System.getProperty("line.separator")
+						+ "Are you running from within Eclipse? (or just not with Jar)  Then make sure your"
+						+ " 'eclipse.expeditee.home' property is set correctly.  It is currently: '"
+						+ System.getProperty("eclipse.expeditee.home")
+						+ "'"
+						+ System.getProperty("line.separator")
+						+ "You can set it by adding a VM argument.  "
+						+ "Example: -Declipse.expeditee.home=D:\\Desktop\\Research\\expeditee-svn");
+				e.printStackTrace();
+			}
+			if (resource == null) {
+				throw new ClassNotFoundException("No resource for "
+						+ packagePath);
+			}
+			final File directory = new File(resource.getFile());
+
+			final int splitPoint = directory.getPath().indexOf('!');
+			if (splitPoint > 0) {
+				String jarName = directory.getPath().substring(
+						"file:".length(), splitPoint);
+				// Windows HACK
+				if (jarName.indexOf(":") >= 0)
+					jarName = jarName.substring(1);
+
+				if (jarName.indexOf("%20") > 0) {
+					jarName = jarName.replace("%20", " ");
+				}
+				// System.out.println("JarName:" + jarName);
+				try {
+					final JarFile jarFile = new JarFile(jarName);
+					final Enumeration<?> entries = jarFile.entries();
+					while (entries.hasMoreElements()) {
+						final ZipEntry entry = (ZipEntry) entries.nextElement();
+						final String className = entry.getName();
+						if (className.startsWith(packagePath)) {
+							if (className.endsWith(".class")
+									&& !className.contains("$")) {
+								// The forward slash below is a forwards slash
+								// for
+								// both windows and linux
+
+								String class_forname = className.substring(0,
+										className.length() - 6);
+								class_forname = class_forname.replace('/', '.');
+
+								classes.add(Class.forName(class_forname));
+							}
+						}
+					}
+					try {
+						jarFile.close();
+					} catch (IOException e) {
+						System.err
+						.println("Error attempting to close Jar file");
+						e.printStackTrace();
+					}
+				} catch (IOException e) {
+					System.err.println("Error Instantiating Jar File Object");
+					e.printStackTrace();
+				}
+			} else {
+
+				System.err
+				.println("A Error has occured when trying to use a Jar file to find actions or agents."
+						+ System.getProperty("line.separator")
+						+ "Are you running from within Eclipse? (or just not with Jar)  Then make sure your"
+						+ " 'eclipse.expeditee.home' property is set correctly.  It is currently: '"
+						+ System.getProperty("eclipse.expeditee.home")
+						+ "'"
+						+ System.getProperty("line.separator")
+						+ "You can set it by adding a VM argument.  "
+						+ "Example: -Declipse.expeditee.home=D:\\Desktop\\Research\\expeditee-svn");
+			}
+		} else {
+			String eclipse_expeditee_home = System.getProperty(
+					"eclipse.expeditee.home", "");
+			String full_package_path = eclipse_expeditee_home + File.separator
+					+ "bin" + File.separator + packagePath;
+
+			final File directory = new File(full_package_path);
+
+			if (directory.exists()) {
+				// Get the list of the files contained in the package
+				String[] files = directory.list();
+				for (int i = 0; i < files.length; i++) {
+					// we are only interested in .class files
+					if (files[i].endsWith(".class") && !files[i].contains("$")
+							&& !files[i].equals("Actions.class")) {
+						// removes the .class extension
+						classes.add(Class.forName(pckgname
+								+ files[i].substring(0, files[i].length() - 6)));
+					}
+				}
+			} else {
+				throw new ClassNotFoundException("The package '" + pckgname
+						+ "' in the directory '" + directory
+						+ "' does not appear to be a valid package");
+			}
 		}
-	    } catch (final Exception e) {
-		System.err.println("Failed to process file: " + packageName);
-		e.printStackTrace();
-	    }
-	} else {
-	    // loop through files in classpath
-
-	    String packageURLString = packageURL.toString();
-	    try {
-		URI uri = new URI(packageURLString);
-		File folder = new File(uri.getPath());
-
-		List<String> files = findFiles(folder);
-		for (String s : files) {
-		    String entryName = realPackageName + s;
-
-		    if (entryName.endsWith(".class")
-			    && !entryName.contains("$")) {
-			entryName = entryName.substring(0,
-				entryName.lastIndexOf('.'));
-			entryName = entryName.replace('/', '.');
-
-			names.add(entryName);
-			classes.add(Class.forName(entryName));
-		    }
-		}
-	    } catch (Exception e) {
-		System.err.println("Failed to process file: "
-			+ packageURLString);
-		e.printStackTrace();
-	    }
+		return classes;
 	}
 
-	return classes;
-    }
-
-    /**
-     * Finds all files in a directory and it's subdirectories
-     * 
-     * @param directory
-     *            The folder to start in
-     * 
-     * @return A list of Strings containing file paths relative to the starting
-     *         directory
-     */
-    private static List<String> findFiles(File directory) {
-	List<String> files = new LinkedList<String>();
-	for (File f : directory.listFiles()) {
-	    if (f.isDirectory()) {
-		for (String s : findFiles(f)) {
-		    files.add(f.getName() + "/" + s);
-		}
-	    } else {
-		files.add(f.getName());
-	    }
-	}
-	return files;
-    }
-
-    public static List<Class<?>> getClasses(final String pckgname)
-	    throws ClassNotFoundException {
-
-	final ArrayList<Class<?>> classes = new ArrayList<Class<?>>();
-
-	// Must be a forward slash for loading resources
-	final String packagePath = pckgname.replace('.', '/');
-
-	if (System.getProperty("eclipse.expeditee.home") == null) {
-	    final ClassLoader cld = Thread.currentThread()
-		    .getContextClassLoader();
-	    if (cld == null) {
-		throw new ClassNotFoundException("Can't get class loader.");
-	    }
-	    URL resource = null;
-	    try {
-		final Enumeration<URL> resources = cld
-			.getResources(packagePath);
-		while (resources.hasMoreElements()) {
-		    URL url = resources.nextElement();
-		    resource = url;
-		}
-	    } catch (IOException e) {
-		System.err
-			.println("A IO Error has occured when trying to use the ContextClassLoader"
-				+ System.getProperty("line.separator")
-				+ "Are you running from within Eclipse? (or just not with Jar)  Then make sure your"
-				+ " 'eclipse.expeditee.home' property is set correctly.  It is currently: '"
-				+ System.getProperty("eclipse.expeditee.home")
-				+ "'"
-				+ System.getProperty("line.separator")
-				+ "You can set it by adding a VM argument.  "
-				+ "Example: -Declipse.expeditee.home=D:\\Desktop\\Research\\expeditee-svn");
-		e.printStackTrace();
-	    }
-	    if (resource == null) {
-		throw new ClassNotFoundException("No resource for "
-			+ packagePath);
-	    }
-	    final File directory = new File(resource.getFile());
-
-	    final int splitPoint = directory.getPath().indexOf('!');
-	    if (splitPoint > 0) {
-		String jarName = directory.getPath().substring(
-			"file:".length(), splitPoint);
-		// Windows HACK
-		if (jarName.indexOf(":") >= 0)
-		    jarName = jarName.substring(1);
-
-		if (jarName.indexOf("%20") > 0) {
-		    jarName = jarName.replace("%20", " ");
-		}
-		// System.out.println("JarName:" + jarName);
-		try {
-		    final JarFile jarFile = new JarFile(jarName);
-		    final Enumeration<?> entries = jarFile.entries();
-		    while (entries.hasMoreElements()) {
-			final ZipEntry entry = (ZipEntry) entries.nextElement();
-			final String className = entry.getName();
-			if (className.startsWith(packagePath)) {
-			    if (className.endsWith(".class")
-				    && !className.contains("$")) {
-				// The forward slash below is a forwards slash
-				// for
-				// both windows and linux
-
-				String class_forname = className.substring(0,
-					className.length() - 6);
-				class_forname = class_forname.replace('/', '.');
-
-				classes.add(Class.forName(class_forname));
-			    }
-			}
-		    }
-		    try {
-			jarFile.close();
-		    } catch (IOException e) {
-			System.err
-				.println("Error attempting to close Jar file");
-			e.printStackTrace();
-		    }
-		} catch (IOException e) {
-		    System.err.println("Error Instantiating Jar File Object");
-		    e.printStackTrace();
-		}
-	    } else {
-
-		System.err
-			.println("A Error has occured when trying to use a Jar file to find actions or agents."
-				+ System.getProperty("line.separator")
-				+ "Are you running from within Eclipse? (or just not with Jar)  Then make sure your"
-				+ " 'eclipse.expeditee.home' property is set correctly.  It is currently: '"
-				+ System.getProperty("eclipse.expeditee.home")
-				+ "'"
-				+ System.getProperty("line.separator")
-				+ "You can set it by adding a VM argument.  "
-				+ "Example: -Declipse.expeditee.home=D:\\Desktop\\Research\\expeditee-svn");
-	    }
-	} else {
-	    String eclipse_expeditee_home = System.getProperty(
-		    "eclipse.expeditee.home", "");
-	    String full_package_path = eclipse_expeditee_home + File.separator
-		    + "bin" + File.separator + packagePath;
-
-	    final File directory = new File(full_package_path);
-
-	    if (directory.exists()) {
-		// Get the list of the files contained in the package
-		String[] files = directory.list();
-		for (int i = 0; i < files.length; i++) {
-		    // we are only interested in .class files
-		    if (files[i].endsWith(".class") && !files[i].contains("$")
-			    && !files[i].equals("Actions.class")) {
-			// removes the .class extension
-			classes.add(Class.forName(pckgname
-				+ files[i].substring(0, files[i].length() - 6)));
-		    }
-		}
-	    } else {
-		throw new ClassNotFoundException("The package '" + pckgname
-			+ "' in the directory '" + directory
-			+ "' does not appear to be a valid package");
-	    }
-	}
-	return classes;
-    }
-
 }
Index: /trunk/src/org/expeditee/settings/Settings.java
===================================================================
--- /trunk/src/org/expeditee/settings/Settings.java	(revision 1101)
+++ /trunk/src/org/expeditee/settings/Settings.java	(revision 1102)
@@ -26,5 +26,4 @@
 
 import org.expeditee.gui.AttributeValuePair;
-import org.expeditee.gui.DisplayIO;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameCreator;
@@ -32,5 +31,4 @@
 import org.expeditee.gui.FrameUtils;
 import org.expeditee.gui.MessageBay;
-import org.expeditee.items.Item;
 import org.expeditee.items.Text;
 import org.expeditee.items.widgets.Password;
@@ -56,14 +54,11 @@
 			// populate map of settings
 			for(Field f : clazz.getFields()) {
-				// only allow valid types
-				if(! Setting.class.isAssignableFrom(f.getType())) {
-					continue;
-				}
+				// Only allow classes that inherit from Setting
+				if(!Setting.class.isAssignableFrom(f.getType())) continue;
+				
 				try {
 					Setting s = (Setting) f.get(null);
 	                settings.put(f.getName().toLowerCase(), s);
-	                if(s instanceof VariableSetting) {
-	                	settingsList.add((VariableSetting) s);
-	                }
+	                if (s instanceof VariableSetting) settingsList.add((VariableSetting) s);
 	                orderedEntries.add(f.getName());
                 } catch (Exception e) {
@@ -71,5 +66,7 @@
                 }
 			}
+			
 			Method m = null;
+			
 			try {
 				m = clazz.getMethod("onParsed", Text.class);
@@ -77,22 +74,27 @@
 				// System.err.println(clazz.getName() + " has no onParsed(Text t) callback");
 			}
+			
 			this.onParsed = m;
 		}
 	}
+	
 	private static HashMap<String, PageDescriptor> _pages = new HashMap<String, PageDescriptor>();
 
 	private static boolean _init = false;
-	public static void Init() {
+	
+	public static void Init()
+	{
 		if(_init) return;
+		
 		_init = true;
+		
 		try {
 			for(Class<?> clazz : PackageLoader.getClassesNew(SETTINGS_PACKAGE)) {
 				// Ignore this class since it's the controller
-				if(clazz.equals(Settings.class)) {
-					continue;
-				}
-				String settingsPage = clazz.getPackage().getName().toLowerCase().substring(SETTINGS_PACKAGE_PARENT.length());
+				if(clazz.equals(Settings.class)) continue;
+				
+				String settingsPageName = clazz.getPackage().getName().toLowerCase().substring(SETTINGS_PACKAGE_PARENT.length());
 				// System.out.println(settingsPage + " : " + clazz.getName());
-				_pages.put(settingsPage, new PageDescriptor(clazz));
+				_pages.put(settingsPageName, new PageDescriptor(clazz));
 			}
 
@@ -100,22 +102,19 @@
 			e.printStackTrace();
 		}
-		FrameUtils.ParseProfile(FrameIO.LoadProfile(UserSettings.ProfileName.get()));
-	}
-	
-	/**
-	 * Parses the settings tree, then resets any settings that were not set
-	 */
-	public static void parseSettings(Text text) {
+	}
+	
+	/** Parses the settings tree, then resets any settings that were not set. */
+	public static void parseSettings(Text text)
+	{
 		List<VariableSetting> set = parseSettings(text, "");
 		List<VariableSetting> toDefault = new LinkedList<VariableSetting>();
-		for(PageDescriptor pd : _pages.values()) {
-			toDefault.addAll(pd.settingsList);
-		}
+		
+		for(PageDescriptor pd : _pages.values()) toDefault.addAll(pd.settingsList);
+		
 		toDefault.removeAll(set);
+		
 		for(VariableSetting s : toDefault) {
 			try {
-				// System.out.println("Resetting " + s.getTooltip());
 	            s.reset();
-	            // System.out.println("Set " + f.getName() + " to default value " + f.get(null));
             } catch (Exception e) {
 	            e.printStackTrace();
@@ -135,13 +134,13 @@
 		
 		List<VariableSetting> set = new LinkedList<VariableSetting>();
+		
 		Frame child = text.getChild();
-		if(child == null) {
-			return set;
-		}
+		
+		if(child == null) return set;
+		
 		String settingsPage = prefix + text.getText().trim().toLowerCase().replaceAll("^@", "");
 		PageDescriptor pd = _pages.get(settingsPage);
-		if(pd == null) {
-			return set;
-		}
+		if(pd == null) return set;
+		
 		try {
 			// set the fields
@@ -160,4 +159,5 @@
 				}
 			}
+			
 			// parse all the settings items on this page
 			for(Text t : items) {				
@@ -186,8 +186,7 @@
 							}
 						}
-						// System.out.println(s);
-						if(s == null) {
-							continue;
-						}
+
+						if(s == null) continue;
+						
 						if(validPages.size() > 1) {
 							StringBuffer warnMessage = new StringBuffer("Found multiple matching settings in the following settings subpages: ");
@@ -202,19 +201,22 @@
 						}
 					}
-					if(s.setSetting(t) && s instanceof VariableSetting) {
-						set.add((VariableSetting) s);
-					}
+					
+					if(s.setSetting(t) && s instanceof VariableSetting) set.add((VariableSetting) s);
+					
 				} catch (Exception e) {
 					e.printStackTrace();
 				}
 			}
+			
 			// call the onParsed method if one exists
 			if(pd.onParsed != null) {
 				pd.onParsed.invoke(null, text);
 			}
+			
         } catch (Exception e) {
             e.printStackTrace();
             return set;
         }
+		
 		// if the page was a settings page, check if it has any subpages
 		for(Text t : child.getTextItems()) {
@@ -224,14 +226,12 @@
 	}
 	
-	public static void generateSettingsTree(Text link) {
+	public static void generateSettingsTree(Text link)
+	{
 		generateSettingsTree("settings", link);
 	}
 	
-	/**
-	 * 
-	 * Generates settings tree
-	 * 
-	 */
-	private static void generateSettingsTree(String page, Text text) {
+	/** Generates settings tree */
+	private static void generateSettingsTree(String page, Text text)
+	{
 		FrameCreator frames = new FrameCreator(text.getParentOrCurrentFrame().getFramesetName(), text.getParentOrCurrentFrame().getPath(), page, false, false);
 		// Frame frame = FrameIO.CreateFrame(text.getParentOrCurrentFrame().getFramesetName(), page, null);
Index: /trunk/src/org/expeditee/settings/network/proxy/ProxySettings.java
===================================================================
--- /trunk/src/org/expeditee/settings/network/proxy/ProxySettings.java	(revision 1101)
+++ /trunk/src/org/expeditee/settings/network/proxy/ProxySettings.java	(revision 1102)
@@ -23,5 +23,6 @@
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
+import org.expeditee.items.widgets.JavaFXSwingWidget;
 import org.expeditee.items.widgets.Password;
 import org.expeditee.items.widgets.WidgetCorner;
@@ -52,5 +53,5 @@
 						if (passwordWidget == null) {
 							try {
-								passwordWidget = (Password) InteractiveWidget.createWidget((Text) i);
+								passwordWidget = (Password) Widget.createWidget((Text) i);
 								if (Pass.get() != null) {
 									// MessageBay.displayMessage("pass was defined multiple times!", Color.ORANGE);
@@ -65,5 +66,5 @@
 			} else if(i instanceof WidgetCorner || i instanceof WidgetEdge) {
 				if(passwordWidget == null) {
-					InteractiveWidget iw;
+					Widget iw;
 					if(i instanceof WidgetCorner) {
 						iw = ((WidgetCorner)i).getWidgetSource();
@@ -73,4 +74,6 @@
 					if(iw instanceof Password) {
 						passwordWidget = (Password) iw;
+					} else if (iw instanceof JavaFXSwingWidget && ((JavaFXSwingWidget) iw).getSwingWidget() instanceof Password) {
+						passwordWidget = (Password) ((JavaFXSwingWidget) iw).getSwingWidget();
 					}
 					if(Pass.get() != null) {
Index: /trunk/src/org/expeditee/stats/SessionStats.java
===================================================================
--- /trunk/src/org/expeditee/stats/SessionStats.java	(revision 1101)
+++ /trunk/src/org/expeditee/stats/SessionStats.java	(revision 1102)
@@ -19,6 +19,4 @@
 package org.expeditee.stats;
 
-import java.awt.event.KeyEvent;
-import java.awt.event.MouseEvent;
 import java.sql.Time;
 import java.util.ArrayList;
@@ -27,7 +25,7 @@
 import java.util.List;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gio.input.KBMInputEvent;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FrameUtils;
 import org.expeditee.gui.TimeKeeper;
@@ -103,5 +101,5 @@
 		stats.append(getCharacterStats());
 
-		stats.append("Version: ").append(DisplayIO.TITLE);
+		stats.append("Version: ").append(DisplayController.TITLE);
 
 		return stats.toString();
@@ -159,6 +157,6 @@
 			chars += counts[i];
 
-		chars -= counts[KeyEvent.VK_BACK_SPACE];
-		chars -= counts[KeyEvent.VK_DELETE];
+		chars -= counts[Text.BACKSPACE_CHARACTER];
+		chars -= counts[Text.DELETE_CHARACTER];
 
 		int EOS = counts['.'] + counts[','] + counts['!'] + counts['?'];
@@ -177,7 +175,7 @@
 		appendStat(stats, "Escape", _EscapeCount);
 		appendStat(stats, "Backspace", _BackspaceCount);
-		appendStat(stats, "Left", _MouseCounters[MouseEvent.BUTTON1]);
-		appendStat(stats, "Middle", _MouseCounters[MouseEvent.BUTTON2]);
-		appendStat(stats, "Right", _MouseCounters[MouseEvent.BUTTON3]);
+		appendStat(stats, "Left", _MouseCounters[KBMInputEvent.MouseButton.LEFT.ordinal()]);
+		appendStat(stats, "Middle", _MouseCounters[KBMInputEvent.MouseButton.MIDDLE.ordinal()]);
+		appendStat(stats, "Right", _MouseCounters[KBMInputEvent.MouseButton.RIGHT.ordinal()]);
 
 		return stats.toString();
@@ -231,7 +229,7 @@
 	 *            ascii value for the typed character
 	 */
-	public static void TypedChar(int ch) {
-		if (ch == KeyEvent.VK_BACK_SPACE || ch == KeyEvent.VK_DELETE)
-			_BackspaceCount++;
+	public static void TypedChar(int ch)
+	{
+		if (ch == ((int) Text.BACKSPACE_CHARACTER) || ch == ((int) Text.DELETE_CHARACTER)) _BackspaceCount++;
 		UserEvent();
 		_CharCounts[ch]++;
@@ -252,5 +250,5 @@
 
 		_FrameEvents.add(Formatter.getTimeWithMillis(elapsedTime) + " "
-				+ DisplayIO.getMouseX() + " " + FrameMouseActions.getY() + " "
+				+ DisplayController.getMouseX() + " " + DisplayController.getMouseY() + " "
 				+ description);
 	}
@@ -278,7 +276,7 @@
 	}
 
-	public static void MouseClicked(int button) {
+	public static void MouseClicked(KBMInputEvent.MouseButton button) {
 		UserEvent();
-		_MouseCounters[button]++;
+		_MouseCounters[button.ordinal()]++;
 	}
 
Index: /trunk/src/org/expeditee/stats/StatsFrame.java
===================================================================
--- /trunk/src/org/expeditee/stats/StatsFrame.java	(revision 1101)
+++ /trunk/src/org/expeditee/stats/StatsFrame.java	(revision 1102)
@@ -19,8 +19,9 @@
 package org.expeditee.stats;
 
-import java.awt.event.MouseEvent;
 import java.lang.reflect.Method;
 import java.util.HashMap;
 import java.util.Map;
+
+import org.expeditee.gio.input.KBMInputEvent;
 
 public class StatsFrame extends SessionStats {
@@ -162,13 +163,13 @@
 	
 	public static String getLeftButtonCount() {
-		return _MouseCounters[MouseEvent.BUTTON1] + "";
+		return _MouseCounters[KBMInputEvent.MouseButton.LEFT.ordinal()] + "";
 	}
 	
 	public static String getMiddleButtonCount() {
-		return _MouseCounters[MouseEvent.BUTTON2] + "";
+		return _MouseCounters[KBMInputEvent.MouseButton.MIDDLE.ordinal()] + "";
 	}
 	
 	public static String getRightButtonCount() {
-		return _MouseCounters[MouseEvent.BUTTON3] + "";
+		return _MouseCounters[KBMInputEvent.MouseButton.RIGHT.ordinal()] + "";
 	}
 }
Index: /trunk/src/org/expeditee/taskmanagement/EntitySaveManager.java
===================================================================
--- /trunk/src/org/expeditee/taskmanagement/EntitySaveManager.java	(revision 1101)
+++ /trunk/src/org/expeditee/taskmanagement/EntitySaveManager.java	(revision 1102)
@@ -24,9 +24,7 @@
 import java.util.Set;
 
-import javax.swing.SwingUtilities;
-
 
 /**
- * Manages time/resource-consuming saving procedures. For enties in an expeditee Frame that
+ * Manages time/resource-consuming saving procedures. For entities in an expeditee Frame that
  * requires heavy-duty saving, implement the entity as a SaveableEntity.
  * 
@@ -135,5 +133,5 @@
 	 * Saves all current registered entities and clears registrations.
 	 * 
-	 * Returns immediatly.
+	 * Returns immediately.
 	 */
 	public synchronized void saveAll() {
@@ -167,5 +165,5 @@
 	/**
 	 * If something is saving, this will block the thread until all entities that
-	 * have been requested to be saved has finished their saving proccesses.
+	 * have been requested to be saved has finished their saving processes.
 	 * 
 	 * @throws InterruptedException 
@@ -237,6 +235,6 @@
 				if (entity.doesNeedSaving()) {
 					
-					// notify observers that save has started - on swing thread
-					SwingUtilities.invokeLater(new SafeFireEvent(entity, true));
+					// notify observers that save has started
+					(new SafeFireEvent(entity, true)).run();
 	
 					// Complete the save
@@ -248,5 +246,5 @@
 	
 					// notify observers that save has finished - on swing thread
-					SwingUtilities.invokeLater(new SafeFireEvent(entity, false));
+					(new SafeFireEvent(entity, false)).run();
 				}
 			}
@@ -254,5 +252,5 @@
 		
 		/**
-		 * Notifies all listners of save start/completion event when run.
+		 * Notifies all listeners of save start/completion event when run.
 		 * 
 		 * @author Brook Novak
